<?php

use Symfony\Component\HttpKernel\Kernel;
use Symfony\Component\Config\Loader\LoaderInterface;

class AppKernel extends Kernel
{
  public function registerBundles()
  {
    $bundles = [
      new Symfony\Bundle\FrameworkBundle\FrameworkBundle(),
      new Symfony\Bundle\SecurityBundle\SecurityBundle(),
      new Symfony\Bundle\TwigBundle\TwigBundle(),
      new Symfony\Bundle\MonologBundle\MonologBundle(),
      new Symfony\Bundle\SwiftmailerBundle\SwiftmailerBundle(),
      new Doctrine\Bundle\DoctrineBundle\DoctrineBundle(),
      new Sensio\Bundle\FrameworkExtraBundle\SensioFrameworkExtraBundle(),
      new Symfony\Bundle\WebServerBundle\WebServerBundle(),

      // -------------------------------
      // CMS Third party bundles
      // -------------------------------
      new Bazookas\AdminBundle\BazookasAdminBundle(),
//      new Bazookas\MediaBundle\BazookasMediaBundle(),
      new Bazookas\CommonBundle\BazookasCommonBundle(),
      new Bazookas\ExportBundle\BazookasExportBundle(),
      // -------------------------------
      // API Third party bundles
      // -------------------------------
      new Bazookas\APIFrameworkBundle\BazookasAPIFrameworkBundle(),

      // -------------------------------
      // Shared Third party bundles
      // -------------------------------
      new FOS\UserBundle\FOSUserBundle(),
      new Liip\ImagineBundle\LiipImagineBundle(),
      new Bazookas\CronBundle\BazookasCronBundle(),

      // -------------------------------
      // Project bundles
      // -------------------------------
      new WebsiteBundle\WebsiteBundle(),

      new SunCat\MobileDetectBundle\MobileDetectBundle(),
    ];

    if (in_array($this->getEnvironment(), ['dev', 'test'], true)) {
      $bundles[] = new Symfony\Bundle\DebugBundle\DebugBundle();
      $bundles[] = new Symfony\Bundle\WebProfilerBundle\WebProfilerBundle();
      $bundles[] = new Sensio\Bundle\DistributionBundle\SensioDistributionBundle();
      $bundles[] = new Sensio\Bundle\GeneratorBundle\SensioGeneratorBundle();
      $bundles[] = new Doctrine\Bundle\FixturesBundle\DoctrineFixturesBundle();
      $bundles[] = new Liip\FunctionalTestBundle\LiipFunctionalTestBundle();

      $bundles[] = new Bazookas\GeneratorBundle\BazookasGeneratorBundle();
    }

    return $bundles;
  }

  public function getRootDir()
  {
    return __DIR__;
  }

  public function getCacheDir()
  {
    return dirname(__DIR__).'/var/cache/'.$this->getEnvironment();
  }

  public function getLogDir()
  {
    return dirname(__DIR__).'/var/logs';
  }

  public function registerContainerConfiguration(LoaderInterface $loader)
  {
    $loader->load($this->getRootDir().'/config/config_'.$this->getEnvironment().'.yml');
  }
}
