<?php

namespace WebsiteBundle\Entity;

use Bazookas\CommonBundle\Entity\Base\BaseEntity;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity(repositoryClass="WebsiteBundle\Repository\ExperimentConditionRepository")
 * @ORM\HasLifecycleCallbacks
 */
class ExperimentCondition extends BaseEntity {

  const GAMIFICATION_LOW = 'low';
  const GAMIFICATION_HIGH = 'high';

  /**
   * @ORM\ManyToOne(targetEntity="Experiment", inversedBy="conditions")
   * @var Experiment
   */
  private $experiment;

  /**
   * @var string
   * @ORM\Column(type="string")
   */
  private $gamificationLevel;

  /**
   * @var string
   * @ORM\Column(type="string")
   */
  private $testGroup;

  /**
   * @var string
   * @ORM\Column(type="string")
   */
  private $startSurveyUrl;

  /**
   * @var string
   * @ORM\Column(type="string")
   */
  private $endSurveyUrl;

  /**
   * @ORM\OneToMany(targetEntity="WebsiteBundle\Entity\Participant", mappedBy="condition"))
   * @var Participant[]
   */
  private $participants;

  /**
   * @return Experiment
   */
  public function getExperiment()
  {
    return $this->experiment;
  }

  /**
   * @param Experiment $experiment
   * @return ExperimentCondition
   */
  public function setExperiment(Experiment $experiment)
  {
    $this->experiment = $experiment;

    return $this;
  }

  /**
   * @return string
   */
  public function getGamificationLevel()
  {
    return $this->gamificationLevel;
  }

  /**
   * @param string $gamificationLevel
   * @return ExperimentCondition
   */
  public function setGamificationLevel($gamificationLevel)
  {
    $this->gamificationLevel = $gamificationLevel;

    return $this;
  }

  /**
   * @return string
   */
  public function getTestGroup()
  {
    return $this->testGroup;
  }

  /**
   * @param string $testGroup
   * @return ExperimentCondition
   */
  public function setTestGroup($testGroup)
  {
    $this->testGroup = $testGroup;

    return $this;
  }

  /**
   * @return string
   */
  public function getStartSurveyUrl()
  {
    return $this->startSurveyUrl;
  }

  /**
   * @param string $startSurveyUrl
   * @return ExperimentCondition
   */
  public function setStartSurveyUrl($startSurveyUrl)
  {
    $this->startSurveyUrl = $startSurveyUrl;

    return $this;
  }

  /**
   * @return string
   */
  public function getEndSurveyUrl()
  {
    return $this->endSurveyUrl;
  }

  /**
   * @param string $endSurveyUrl
   * @return ExperimentCondition
   */
  public function setEndSurveyUrl($endSurveyUrl)
  {
    $this->endSurveyUrl = $endSurveyUrl;

    return $this;
  }

  /**
   * @return Participant[]
   */
  public function getParticipants(): array
  {
    return $this->participants;
  }

  /**
   * @param Participant[] $participants
   * @return ExperimentCondition
   */
  public function setParticipants(array $participants): ExperimentCondition
  {
    $this->participants = $participants;

    return $this;
  }

}
