<?php

namespace WebsiteBundle\Form\Admin;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use WebsiteBundle\Entity\PsychEducationResponse;

class PsychEducationResponseAdminType extends AbstractType
{

  /**
   * @param FormBuilderInterface $builder
   * @param array $options
   */
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $builder
      ->add('value', TextType::class, [
        'label' => 'admin.entities.psychEducationResponse.fields.value'
      ])
      ->add('isCorrect', CheckboxType::class, [
        'label' => 'admin.entities.psychEducationResponse.fields.isCorrect',
        'required' => false,
        'attr' => [
          'class' => 'js-incorrect-reason'
        ]
      ])
      ->add('incorrectReason', TextareaType::class, [
        'label' => 'admin.entities.psychEducationResponse.fields.incorrectReason',
        'required' => false,
        'conditionallyVisible' => [
          '.js-incorrect-reason' => '!$element.is(":checked")'
        ],
        'conditionalScope' => '.nested-form__item'
      ])
    ;
  }

  /**
   * @param OptionsResolver $resolver
   */
  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults([
      'data_class' => PsychEducationResponse::class,
      'translation_domain' => 'admin'
    ]);
  }
}
