var bazookas = bazookas || {};

bazookas.game = (function () {
  var self = {};

  var $settings = $('#settings');
  var duration = $settings.data('totaltime');
  var interval = $settings.data('interval');
  var type = $settings.data('type');
  var numbers = [];
  var countdown = 6;
  var $countDownTimer = $('#countdown .timer');
  var countdownInterval;
  var posCombo = 0;
  var negCombo = 0;
  var score = 0;
  var gameTimer;
  var totalTimePlayed = 0;
  var totalTimeLeft = duration;
  var maxNumber = 18;
  var answer = 0;
  var level = $settings.data('level');
  var demo = true;
  var randomNumberTimeout = null;
  var clicked = true;
  var urlMoodQuestions = $settings.data('moodurl');
  var ajaxResultUrl = $settings.data('resulturl');
  var sound1, sound2, sound3, sound4, sound5, sound6, sound7, sound8, sound9, sound10, sound11, sound12, sound13,
    sound14, sound15, sound16, sound17, sound18, combo = null;
  var $audio = $('#audio');
  var tutTitle = $audio.data('tutorial-title');
  var tutSubTitle = $audio.data('tutorial-sub');
  var testTitle = $audio.data('test-title');
  var testSubTitle = $audio.data('test-sub');
  var gamification = $settings.data('gamification');
  var pause = false;
  var $btnPause = $('.js-pause');
  var sessionNumber = $settings.data('sessionnumber');
  var $user__score = $('#user__score');
  var $user__answers = $('#user__answers');
  var $total__answers = $('#total__answers');
  var $user_level = $('#user_level');
  var rightAnswers = 0;
  var $comboMeter = $('#combo__meter');
  var availableNumbers = [];
  var inputType = 'Mouse';

  self.init = function () {
    if ($('.game').length > 0) {
      loadAudioFiles();
      if (gamification === 'high' && type !== 'PASAT') {
        updateGamificationInfo();
      }

      if ($settings.data('skiptut') && type !== 'PASAT') {
        demo = false;
        setTitles('realTest');
        hideExample();
      } else {
        demo = true;
        setTitles('tutorial');
      }
    }

    $('.js-sound-test').on('click', playTestSoundClickHandler);
    $('.js-hide-example').on('click', startCountdownClickHandler);
    $btnPause.on('click', continueGameAfterPauseClickHandler);

    if (type === 'PASAT' || type === 'APASAT') {
      maxNumber = 9
    }

    $('.block').on('click', userClickBlockHandler);

    $('body').one('touchend', inputTypeHandler);
  };

  function inputTypeHandler(event) {
    inputType = 'Touch';
  }

  function updateGamificationInfo() {
    $user__answers.text(rightAnswers);
    $user_level.text(level);
    $total__answers.text(numbers.length);
    $user__score.text(score);
  }

  function continueGameAfterPauseClickHandler() {
    togglePauseScreen();
    pause = false;
    gameTimer = setInterval(updateGameTimerBar, 1000);
    playLastNumberAgain();
  }

  function playLastNumberAgain() {
    playNumberSound(numbers[numbers.length - 1].number);
    setTimeout(createRandomNumber, interval);
  }

  function togglePauseScreen() {
    var $parent = $btnPause.parent();

    $parent
      .toggleClass('show')
      .toggleClass('hide');
  }

  function setTitles(type) {
    if (type === 'tutorial') {
      $('.js-game-title').text(tutTitle);
      $('.js-game-sub').text(tutSubTitle);
    } else {
      $('.js-game-title').text(testTitle);
      $('.js-game-sub').text(testSubTitle);
    }
  }

  function loadAudioFiles() {
    var path = $audio.data('url');

    sound1 = new Howl({
      src: [path.replace('[digit]', '1')]
    });
    sound2 = new Howl({
      src: [path.replace('[digit]', '2')]
    });
    sound3 = new Howl({
      src: [path.replace('[digit]', '3')]
    });
    sound4 = new Howl({
      src: [path.replace('[digit]', '4')]
    });
    sound5 = new Howl({
      src: [path.replace('[digit]', '5')]
    });
    sound6 = new Howl({
      src: [path.replace('[digit]', '6')]
    });
    sound7 = new Howl({
      src: [path.replace('[digit]', '7')]
    });
    sound8 = new Howl({
      src: [path.replace('[digit]', '8')]
    });
    sound9 = new Howl({
      src: [path.replace('[digit]', '9')]
    });
    sound10 = new Howl({
      src: [path.replace('[digit]', '10')]
    });
    sound11 = new Howl({
      src: [path.replace('[digit]', '11')]
    });
    sound12 = new Howl({
      src: [path.replace('[digit]', '12')]
    });
    sound13 = new Howl({
      src: [path.replace('[digit]', '13')]
    });
    sound14 = new Howl({
      src: [path.replace('[digit]', '14')]
    });
    sound15 = new Howl({
      src: [path.replace('[digit]', '15')]
    });
    sound16 = new Howl({
      src: [path.replace('[digit]', '16')]
    });
    sound17 = new Howl({
      src: [path.replace('[digit]', '17')]
    });
    sound18 = new Howl({
      src: [path.replace('[digit]', '18')]
    });
    combo = new Howl({
      src: [path.replace('[digit]', 'combo')]
    });
  }

  function playTestSoundClickHandler() {
    sound5.play();
  }

  function hideExample() {
    var $realTest = $('.real__test');

    $realTest.addClass('show').hide();
    setTimeout(function () {
      var $game = $('.game');
      $realTest.show();
      $game.removeClass('show');
      $game.hide();
    }, 500);
  }

  function startCountdownClickHandler() {
    var color = $('#sessionColor').attr('class');
    $('body').addClass('session-' + color);

    countdown = 4;

    if (numbers.length > 4) {
      setTitles('real');
      demo = false;
      numbers = [];
      availableNumbers = [];
      fillNumberArray();
    }

    $('.game__container').addClass('no-clicks');
    countdownInterval = setInterval(startCountDown, 1000);
  }

  function startCountDown() {
    if (countdown > 0) {
      $('.game__container').addClass('no-clicks');
      $('#countdown').addClass('show');
      countdown--;
      $countDownTimer.text(countdown);
    } else {
      clearInterval(countdownInterval);
      $('.game__container').removeClass('no-clicks');
      $('#countdown').removeClass('show');
      startGame();
    }
  }

  function startGame() {
    if (!demo) {
      gameTimer = setInterval(updateGameTimerBar, 1000);
    }

    createRandomNumber();
  }

  function updateGameTimerBar() {
    if (type !== "PASAT" && totalTimePlayed > duration) {
      $('.game__duration__timer').width(0);
      endGameHandler();
    } else {
      totalTimePlayed++;
      var barWidth = Math.ceil(100 - ((totalTimePlayed / duration) * 100));
      $('.game__duration__timer').width(barWidth + '%');
    }

    $('.timeLeft').text(formatToTime(Math.max(0, Math.floor(duration - totalTimePlayed))));
  }

  function formatToTime(secs) {
    var hours = 0;
    var mins = 0;

    if (secs > 60) {
      mins = Math.floor(secs / 60);
      if (mins < 60) {
        secs = (secs - (mins * 60));
      } else {
        hours = Math.floor(mins / 60);
        mins = mins - (hours * 60);
        secs = secs - (mins * 60);
      }
    }

    //Do the substring magic to make sure its always preceded by a 0, this allows us to get time in a
    //01:10:05 format. Also don't include hours if there aren't any (which will be almost always).
    var formattedMinutes = ('0' + mins ).slice(-2);
    var formattedSecs = ('0' + secs ).slice(-2);

    if (hours > 0) {
      var formattedHours = ('0' + hours ).slice(-2);
      return formattedHours + ':' + formattedMinutes + ':' + formattedSecs;
    } else {
      return formattedMinutes + ':' + formattedSecs;
    }
  }

  function endGameHandler() {
    resetGame();
    sendResultToServer();
  }

  function fillNumberArray() {
    if (type === 'CONTROL') {
      for (var i = 1; i < 19; i++) {
        availableNumbers.push(i);
      }
    } else {
      for (var i = 1; i < 10; i++) {
        availableNumbers.push(i);
      }
    }
  }

  function createRandomNumber() {
    if (!pause && totalTimeLeft > 2) {
      //set a timeout for playing the next number
      randomNumberTimeout = setTimeout(createRandomNumber, interval);

      $('.block').removeClass('correct incorrect clicked');

      if (type === "PASAT") {
        if (!demo && (numbers.length === 60 || numbers.length === 120)) {
          //This is the last question before showing the pause screen so immediatly clear the random number timeout
          clearTimeout(randomNumberTimeout);

          setTimeout(function () {
            pause = true;
            clearInterval(gameTimer);
            togglePauseScreen();

            //Correct the total time left during the PASAT to account for drifts in the timer due to execution time
            //We can do this because at the end of each series the countdown timer should be at a certain point so make sure its set to that

            //In every series 60 questions must be answered. So multiply by 61 to include the time for answering the last question itself.
            if (numbers.length < 119) {
              // End of series 1 = 183 = 3 * 61;
              // and do a floor of the time we should be at to give ourselves some extra margin
              totalTimePlayed = 183;
            } else {
              //End of series 2 = 303 =  183 + (2 * 60)
              //and do a floor of the time we should be at to give ourselves some extra margin
              totalTimePlayed = 303;
            }
          }, interval);
        }

        if (numbers.length >= 181) {
          endGameHandler();
          return;
        } else {
          if (numbers.length > 60 && numbers.length <= 120) {
            interval = 2000;
          } else if (numbers.length > 120) {
            interval = 1500;
          }
        }
      }

      if (demo === true && numbers.length > 5) {
        hideExample();
        resetGame();
      } else {
        if (availableNumbers.length === 0) {
          fillNumberArray();
        }

        var number = availableNumbers[Math.ceil(Math.random() * availableNumbers.length - 1)];

        for (var i = 0; i < availableNumbers.length; i++) {
          if (availableNumbers[i] === number) {
            availableNumbers.splice(i, 1);
          }
        }

        var prevNumber = 0;
        var newNumber = {};
        var createdDate = new Date();

        if (numbers.length > 0) {
          var currentQuestionIndex = numbers.length - 1;

          if (!clicked) {
            numbers[currentQuestionIndex].answer = null;
            numbers[currentQuestionIndex].reactionSpeed = 0;
          }
          prevNumber = numbers[currentQuestionIndex];
          newNumber = {
            index: prevNumber.index + 1,
            number: number,
            prevNumber: prevNumber.number,
            level: level,
            interval: interval,
            reactionSpeed: 1200,
            created: createdDate,
            score: score
          };
          if (type !== 'CONTROL') {
            newNumber.sum = number + prevNumber.number;
          } else {
            newNumber.sum = number;
          }
          numbers.push(newNumber)
        } else {
          newNumber = {
            index: 1,
            number: number,
            prevNumber: 0,
            sum: number,
            level: level,
            interval: interval,
            reactionSpeed: 1200,
            created: createdDate,
            score: score
          };
          numbers.push(newNumber)
        }

        answer = newNumber.sum;

        if (!clicked && demo !== true) {
          posCombo = 0;

          if (gamification === 'high' && type !== 'PASAT') {
            updateComboMeter();
            updateGamificationInfo();
          }

          if (negCombo < 3) {
            negCombo++
          } else if (negCombo >= 3) {
            negCombo = 0;

            (level - 1) > 0 ? level-- : level = 0;
            if (type !== "PASAT") {
              interval += 100;
            }
          }
        }

        clicked = false;
        playNumberSound(number);
      }
    }
  }

  function playNumberSound(number) {
    switch (number) {
      case 1:
        sound1.play();
        break;
      case 2:
        sound2.play();
        break;
      case 3:
        sound3.play();
        break;
      case 4:
        sound4.play();
        break;
      case 5:
        sound5.play();
        break;
      case 6:
        sound6.play();
        break;
      case 7:
        sound7.play();
        break;
      case 8:
        sound8.play();
        break;
      case 9:
        sound9.play();
        break;
      case 10:
        sound10.play();
        break;
      case 11:
        sound11.play();
        break;
      case 12:
        sound12.play();
        break;
      case 13:
        sound13.play();
        break;
      case 14:
        sound14.play();
        break;
      case 15:
        sound15.play();
        break;
      case 16:
        sound16.play();
        break;
      case 17:
        sound17.play();
        break;
      case 18:
        sound18.play();
        break;
      case 'combo':
        combo.play();

    }
  }

  function userClickBlockHandler(e) {
    if (e.originalEvent === undefined) {
      return;
    }

    var currentQuestionIndex = numbers.length - 1;

    //If this question has previously been answered, then don't bother continuing as otherwise
    //the user will be capable of changing their answer and capable of increasing their score
    if (typeof numbers[currentQuestionIndex].answer !== 'undefined') {
      return;
    }

    var pickedNumber = $(e.currentTarget).find('div').text();
    pickedNumber = parseInt(pickedNumber);

    var $block = $('.block');
    $block.removeClass('correct incorrect clicked');
    var $target = $(e.currentTarget);
    $target.addClass('clicked');

    //If the answer is correct
    if (pickedNumber === answer) {
      handleCorrectAnswer($target);
    } else {
      handleIncorrectAnswer($target, $block)
    }

    var clickedDate = new Date();

    numbers[currentQuestionIndex].answer = pickedNumber;
    numbers[currentQuestionIndex].level = level;
    numbers[currentQuestionIndex].answeredDate = clickedDate;
    numbers[currentQuestionIndex].score = score;

    clicked = true;
    playRandomMotivation();
  }

  function handleCorrectAnswer($target) {
    if (type !== "PASAT" || demo) {
      $target.addClass('correct');
    }

    negCombo = 0;
    var percent = 1 + (((sessionNumber - 1) * 10) / 100);
    score += Math.floor(level * percent);
    rightAnswers++;

    //It was correct so increment our combo count
    posCombo++;

    //Have we now completed 4 items correctly in a row?
    console.log('COMBO: ', posCombo, 'Interval: ', interval);
    if (posCombo >= 4) {
      level++;

      if (type !== "PASAT" && gamification === 'high') {
        updateGamificationInfo();
        updateComboMeter();
      }

      posCombo = 0;
      if (type !== "PASAT") {
        interval -= 100;
      }
    } else {
      if (type !== "PASAT" && gamification === 'high') {
        updateGamificationInfo();
        updateComboMeter();
      }
    }
  }

  function handleIncorrectAnswer($target, $block) {
    if (type !== "PASAT" || demo) {
      $target.addClass('incorrect');
    }

    var blocks = $block;
    for (var i = 0; i < blocks.length; i++) {
      var $item = $(blocks[i]);
      if ($item.find('div').text() == answer) {
        if (type !== "PASAT" || demo) {
          $item.addClass('correct');
        }
      }
    }

    posCombo = 0;
    negCombo++;

    if (negCombo >= 4) {
      negCombo = 0;
      level - 1 > 0 ? level-- : level = 0;
      if (type !== "PASAT") {
        interval += 100;
      }
    }

    if (gamification === 'high' && type !== 'PASAT') {
      updateGamificationInfo();
      updateComboMeter();
    }
  }

  function playRandomMotivation() {
    var $motivations = $('.game__motivation .quote');
    var number = Math.ceil(Math.random() * $motivations.length);
    $motivations.hide();
    $($motivations[number]).show();
  }

  function updateComboMeter() {
    var length = 0;
    var comboParts = $comboMeter.find('.part');

    if (posCombo > 0) {
      length = posCombo;

      for (var i = 0; i < length; i++) {
        var $part = $(comboParts[i]);
        if (!$part.hasClass('active')) {
          $part.addClass('active');
        }
      }

      if (posCombo > 3) {
        playNumberSound('combo');
        $(comboParts[comboParts.length - 1]).addClass('combo');
        setTimeout(function () {
          $(comboParts).removeClass('active combo');
        }, 500);
        posCombo = 0;
      }
    } else {
      $(comboParts).removeClass('active combo');
    }
  }

  function resetGame() {
    clearTimeout(randomNumberTimeout);
    clearInterval(gameTimer);
    countdown = 6;

    $('.block').removeClass('correct incorrect');

    score = 0;
    posCombo = 0;
    negCombo = 0;
    rightAnswers = 0;
    if (gamification === 'high' && type !== 'PASAT') {
      $comboMeter.find('.part').removeClass('active combo');
      updateGamificationInfo();
    }
  }

  function sendResultToServer() {
    var data = createJSONObject();
    $.ajax({
      method: "POST",
      url: ajaxResultUrl,
      data: JSON.stringify(data),
      dataType: "json",
      contentType: "application/json; charset=utf-8"
    })
      .error(function (error) {
        console.error(error);
      })
      .done(function () {
        window.location = urlMoodQuestions;
      })
    ;
  }

  function createJSONObject() {
    var allAnswers = [];

    numbers.forEach(function (number) {
      if (!number.answer) {
        number.reactionSpeed = null;
      } else {
        number.reactionSpeed = number.answeredDate - number.created;
      }

      var ajaxObj = {
        trial: number.index,
        stimulus: number.number,
        correctAnswer: number.sum,
        reactionTime: number.reactionSpeed,
        interval: number.interval,
        answer: number.answer ? number.answer : null,
        level: number.level,
        score: number.score
      };

      allAnswers.push(ajaxObj);
    });

    return {
      inputType: inputType,
      data: allAnswers
    }
  }

  return self;
})();
