<?php

namespace Bazookas\AdminBundle\AdminElements\Containers;

use Bazookas\AdminBundle\AdminElements\Base\BaseAdminElement;

class TableContainer extends BaseAdminElement {

  protected $tableHeading;

  protected $tableData;

  public function __construct($children = [], $options = []) {
    parent::__construct($children, $options);

    $this->tableHeading = $this->options['tableHeading'];
    $this->tableData = $this->options['tableData'];
  }

  protected function getDefaultOptions() {
    $defaults = parent::getDefaultOptions();
    return array_merge($defaults, [
      'template' => 'BazookasAdminBundle:AdminElements/Containers:tableContainer.html.twig',
      'class' => 'table',
      'tableHeading' => [],
      'tableData' => [],
      'columnAlignment' => 'center'
    ]);
  }

  public function getTableHeading() {
    return $this->tableHeading;
  }

  public function setTableHeading(array $heading) {
    $this->tableHeading = $heading;
    return $this;
  }

  public function getTableData() {
    return $this->tableData;
  }

  public function setTableData(array $data) {
    $this->tableData = $data;
    return $this;
  }

  public function getColumnAlignment() {
    return $this->options['columnAlignment'];
  }
}
