<?php

namespace Bazookas\AdminBundle\Controller\AdminController;

use Bazookas\AdminBundle\Controller\Base\BaseAdminListController;
use Bazookas\AdminBundle\Entity\CMSUserGroup;
use Bazookas\AdminBundle\Form\CMSUserGroupAdminType;
use Bazookas\AdminBundle\PageBuilder\Interfaces\ListPageBuilderInterface;
use Bazookas\CommonBundle\Security\Roles;
use Symfony\Component\HttpFoundation\Request;

class BaseUserGroupAdminController extends BaseAdminListController
{
  protected function getEntityClass()
  {
    return CMSUserGroup::class;
  }

  protected function getFormClass($action) {
    switch($action) {
      case self::ACTION_ADD:
        return CMSUserGroupAdminType::class;
      case self::ACTION_EDIT:
        return CMSUserGroupAdminType::class;
      default:
        return null;
    }
  }

  protected function modifyListBuilder(Request $request, ListPageBuilderInterface $builder)
  {
    $builder = parent::modifyListBuilder($request, $builder);

    $builder
      ->addField('name')
      ->addField('roles', [
        'template' => 'BazookasAdminBundle:List/Fields:_list.html.twig'
      ])
    ;

    return $builder;
  }

  protected function hasAccess($action) {
    switch($action) {
      case self::ACTION_LIST:
      case self::ACTION_ADD:
      case self::ACTION_EDIT:
      case self::ACTION_REMOVE:
        return $this->isGranted(Roles::ROLE_ADD_GROUP);
      default:
        return false;
    }
  }


}
