<?php
namespace Bazookas\AdminBundle\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Bazookas\AdminBundle\Util\Copy;

class ImagePreviewType extends AbstractType {

  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults(array(
      'filter' => 'thumbnail',
      'previewFileInput' => null, // id of the field to preview file when uploading
      'translation_domain' => 'admin',
    ));
  }


  public function buildView(FormView $view, FormInterface $form, array $options)
  {
    $copy = Copy::theProperties(array(
      'filter',
      'previewFileInput',
    ))
      ->from($options)
      ->to($view->vars);
  }

  public function getParent() {
    return TextType::class;
  }
}
