<?php
namespace Bazookas\AdminBundle\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\CollectionType;
use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Bazookas\AdminBundle\Util\Copy;

class TranslationFormType extends AbstractType {

  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults(array(
      'by_reference' => false,
      'require_all_locales' => false,
      'allow_add' => true,
      'allow_delete' => true,
      'prototype_name' => '__translation__',
      'error_bubbling' => true,
      'translation_domain' => 'admin'
    ));
  }


  public function buildView(FormView $view, FormInterface $form, array $options)
  {
    Copy::theProperties(array(
      'prototype_name',
      'require_all_locales',
    ))
      ->from($options)
      ->to($view->vars);
  }

  public function getParent() {
    return CollectionType::class;
  }
}
