<?php

namespace Bazookas\AdminBundle\PageBuilder\Base;

abstract class BaseBulkPageBuilder extends BaseFormPageBuilder
{

  /**
   * @var array
   */
  protected $entityIds;

  /**
   * @var Mixed[]
   */
  protected $entities;

  public function getEntityIds()
  {
    return $this->entityIds;
  }

  /**
   * @param int[] $entityIds
   */
  public function setEntityIds(array $entityIds)
  {
    $this->entityIds = $entityIds;
  }

  /**
   * @return \Mixed[]
   */
  public function getEntities()
  {
    if (empty($this->entities) && !empty($this->entityIds)) {
      $entityRepo = $this->entityManager->getRepository($this->entityClass);
      $entities = $entityRepo->findById($this->entityIds);
      $this->entities = $entities;
    }

    return $this->entities;
  }

  /**
   * @param array $entities
   * @return $this
   */
  public function setEntities(array $entities)
  {
    $this->entities = $entities;

    return $this;
  }

}
