<?php
namespace Bazookas\AdminBundle\Util;

/*
Utility class to copy properties from one object to another
*/
class Copy {

  private $_properties;
  private $_from;
  private $_to;

  // initialize functions
  static function theProperties($value) {
    $copy = new Copy();
    return $copy->properties($value);
  }
  static function fromObject($value) {
    $copy = new Copy();
    return $copy->from($value);
  }
  static function toObject(&$value) {
    $copy = new Copy();
    return $copy->to($value);
  }

  /**
  * Set the value of properties
  * @param mixed _properties
  * @return self
  */
  public function properties($_properties)
  {
    $this->_properties = $_properties;
    return $this->tryExecute();
  }

  /**
  * Set the value of from
  * @param mixed _from
  * @return self
  */
  public function from($_from)
  {
    $this->_from = $_from;
    return $this->tryExecute();
  }

  /**
  * Set the value of to
  * @param mixed _to
  * @return self
  */
  public function to(&$_to)
  {
    $this->_to = &$_to;
    return $this->tryExecute();
  }

  private function tryExecute() {
    if (isset($this->_properties) && isset($this->_from) && isset($this->_to)) {
      foreach ($this->_properties as $property) {
        if (is_object($this->_from)) {
          $value = $this->_from->{$property};
        }
        else if (is_array($this->_from)) {
          $value = $this->_from[$property];
        }
        else {
          // if value can not be accessed, not much need in continueing
          return $this;
        }

        if (is_object($this->_to)) {
          $this->_to->{$property} = $value;
        }
        else if (is_array($this->_to)) {
          $this->_to[$property] = $value;
        }
        else {
          // if property can not be set, not much need in continueing
          return $this;
        }
      }
    }
    return $this;
  }

}
