<?php
namespace Bazookas\APIFrameworkBundle\Repository;

use Bazookas\AdminBundle\Repository\Base\BaseRepository;
use Bazookas\AdminBundle\Repository\Interfaces\ListRepositoryInterface;
use Doctrine\ORM\QueryBuilder;

class AppCopyAdminRepository extends BaseRepository implements ListRepositoryInterface
{
  public function beforeListQueryExecution(QueryBuilder $qb, array $params)
  {
    if (!$this->joinExsists($qb, 'e', 'details')) {
      $qb
        ->addSelect('details')
        ->leftJoin('e.details', 'details')
      ;
    }

    return parent::beforeListQueryExecution($qb, $params);
  }
}
